package com.example.juegotocame

import android.animation.ObjectAnimator
import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.os.CountDownTimer
import android.util.DisplayMetrics
import android.view.ViewGroup
import android.widget.Button
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.isVisible
import kotlinx.android.synthetic.main.activity_juego_matame.*


class JuegoMatameActivity : AppCompatActivity() {

    internal val tiempo : Long = 15_000
    internal var puntos : Int = 0
    internal var vida : Int = 100
    internal var jugadorPuntajeRecord = 0
    internal lateinit var jugadorRecord : String
    internal lateinit var jugadorActual : String
    private val ALTO = 3
    private val ANCHO = 4

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_juego_matame)

        val intentRecibido : Intent = intent
        /**Recibe Intent**/
        jugadorActual = intentRecibido.getStringExtra("jugador")
        jugadorRecord = intentRecibido.getStringExtra("jugadorAntiguo")
        jugadorPuntajeRecord = intentRecibido.getIntExtra("jugadorRecordA", 0)
        jugadorIngresado3.text = "Bienvenido $jugadorActual"
        campeon3.text = "Record Anterior \n$jugadorRecord: $jugadorPuntajeRecord"

        matame.isVisible = false
        matame.setText("100%")

        jugar3.setOnClickListener {
            matame.isVisible = true
            matame.isEnabled =true
            volverInicio3.isVisible = false
            campeon3.isVisible = false
            jugar3.isVisible = false
            puntos = 0

            empiezaConteo()
        }



        matame.setOnClickListener {
            puntos+=1
            vida-=5
            matame.setText("${vida}")
            puntajeJuego3.setText("Puntos Alcanzados: $puntos")
            adjustButtonSize(matame)
            ObjectAnimator.ofFloat(matame, "translationX", ((-200..200).random()).toFloat()).apply {
                duration = 100
                start()
            }
            ObjectAnimator.ofFloat(matame, "translationY", ((-200..700).random()).toFloat()).apply {
                duration = 100
                start()
            }


        }

        volverInicio3.setOnClickListener {
            val devolverCampeon : Intent = Intent()
            devolverCampeon.putExtra("jugador_finalizo",jugadorActual)
            devolverCampeon.putExtra("puntaje", puntos)
            devolverCampeon.putExtra("campeonNuevo", jugadorRecord)
            devolverCampeon.putExtra("campeonRecord", jugadorPuntajeRecord)
            setResult(Activity.RESULT_OK,devolverCampeon)
            finish()
        }

    }//fin de onCreate

    private fun adjustButtonSize(button : Button ) {
        //var displayMetrics : DisplayMetrics  = getResources().getDisplayMetrics()
        //var width : Int = displayMetrics.widthPixels
        //var height : Int = displayMetrics.heightPixels
        var params : ViewGroup.LayoutParams  = matame.getLayoutParams()
        params.height -= (ALTO)
        params.width -= (ANCHO)
        button.setLayoutParams(params);
    }

    private fun empiezaConteo()
    {
        object : CountDownTimer(tiempo, 1000) {
            /**onTick se encarga de que el contador disminuya relacion a 1000 ms**/

                override fun onTick(millisUntilFinished: Long) {
                    if (vida == 0) {
                        finish()
                    }
                    tiempoTexto3.setText("00:${millisUntilFinished / 1000}")
                    jugar3.isEnabled = false

                }




                /**onFinish es un metodo que al terminar de contar puede realizar algun procedimiento **/
                override fun onFinish() {
                    termino()
                }

            }.start()

    }// Fin Conteo

    fun termino(){


        if (vida <= 0) tiempoTexto3.setText("Haz vencido con $puntos hits al pobre boton")
        else tiempoTexto3.setText("El boton a uido!")
        jugar3.isEnabled = true
        matame.isEnabled = false

        if (jugadorPuntajeRecord < puntos) {
            puntajeJuego3.setText("$jugadorActual: $puntos\nSupero el Record de $jugadorRecord: $jugadorPuntajeRecord")
            jugadorRecord = jugadorActual
            jugadorPuntajeRecord = puntos
        } else {
            puntajeJuego3.setText("$jugadorActual: $puntos")
        }
        matame.isVisible = false
        volverInicio3.isVisible = true
        jugar3.isVisible = true

    }

}
