package com.example.juegotocame

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.ActionMode
import android.view.Gravity
import android.view.View
import android.widget.Button
import android.widget.EditText
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import kotlinx.android.synthetic.main.activity_main.*

class MainActivity : AppCompatActivity() {
    /**Textos**/
    internal lateinit var jugadorNuevo : EditText

    /**Botones**/
    internal lateinit var registrarJugador : Button

    /**Entidades**/
    internal var jugadorAntiguo : String ="Android"
    internal var jugadorRecordA : Int = 1
    internal val EMPTY_VALUE = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        configView()

        /**Capturas**/
        jugadorNuevo = findViewById(R.id.jugadorNuevo)
        registrarJugador = findViewById(R.id.registrarJugador)

        
        registrarJugador.setOnClickListener{
                if(jugadorNuevo.text.toString() == ""){
                    val mensaje = Toast.makeText(
                        applicationContext,
                        "Por favor Ingrese algun Alias\n\t\t\t\t\tNo sea flojo",
                        Toast.LENGTH_LONG
                    )
                    mensaje.setGravity(Gravity.TOP, 0, 100)
                    mensaje.show()
                }else {
                    SharedApp.prefs.name = jugadorNuevo.text.toString()
                    configView()

                }
        }//fin de registrar Jugador Prueba de captura Nombre
        borrarJugador.setOnClickListener {
            borrarJugador()
            configView()
        }

        juegoTocame.setOnClickListener{
            val intentJuegoTocame : Intent = Intent(this, JuegoTocameActivity::class.java)
            intentJuegoTocame.putExtra("jugador", jugadorNuevo.text.toString())
            intentJuegoTocame.putExtra("jugadorAntiguo", jugadorAntiguo)
            intentJuegoTocame.putExtra("jugadorRecordA", jugadorRecordA)
            startActivityForResult(intentJuegoTocame, 10)
        }

        juegoSigueme.setOnClickListener{
            val intentJuegoPersigueme : Intent = Intent(this, JuegoPersiguemeActivity::class.java)
            intentJuegoPersigueme.putExtra("jugador", jugadorNuevo.text.toString())
            intentJuegoPersigueme.putExtra("jugadorAntiguo", jugadorAntiguo)
            intentJuegoPersigueme.putExtra("jugadorRecordA", jugadorRecordA)
            startActivityForResult(intentJuegoPersigueme, 20)
        }

        juegoMatame.setOnClickListener{
            val intentJuegoMatame : Intent = Intent(this, JuegoMatameActivity::class.java)
            intentJuegoMatame.putExtra("jugador", jugadorNuevo.text.toString())
            intentJuegoMatame.putExtra("jugadorAntiguo", jugadorAntiguo)
            intentJuegoMatame.putExtra("jugadorRecordA", jugadorRecordA)
            startActivityForResult(intentJuegoMatame, 30)
        }


    }//fin de onCreate


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)

        if(data != null){
            if(resultCode == Activity.RESULT_OK){
                jugadorRegistrado.setText("El jugador ${data.getStringExtra("jugador_finalizo")}, hizo ${data.getIntExtra("puntaje", 0)} puntos!")
                jugadorAntiguo = data.getStringExtra("campeonNuevo")!!
                if(jugadorRecordA < data.getIntExtra("campeonRecord", 0)) SharedApp.prefs.puntos = data.getIntExtra("campeonRecord", 0)
                jugadorRecordA = data.getIntExtra("campeonRecord", 0)
            }
        }

    }

    private fun showProfile(){
        jugadorRegistrado.setText("El jugador ${SharedApp.prefs.name}, hizo ${SharedApp.prefs.puntos} puntos!")
        //tvName.text = "Hola ${SharedApp.prefs.name}"
        //btnDeleteValue.visibility = View.VISIBLE
        //campoUsuario.visibility = View.INVISIBLE
        //registrar.visibility = View.INVISIBLE
    }

    private fun showGuest(){
        //jugadorRegistrado.setText("El jugador ${SharedApp.prefs.name}, hizo ${SharedApp.prefs.name} puntos!")
        //tvName.visibility = View.INVISIBLE
        //btnDeleteValue.visibility = View.INVISIBLE
        //campoUsuario.visibility = View.VISIBLE
        //registrar.visibility = View.VISIBL
        if (SharedApp.prefs.name != "") {
            val mensaje = Toast.makeText(
                applicationContext,
                "Bienvenido ${jugadorNuevo.text}",
                Toast.LENGTH_LONG
            )
            mensaje.setGravity(Gravity.TOP, 0, 100)
            mensaje.show()
        }
    }
    private fun configView(){
        if(isSavedName()) showProfile() else showGuest()
    }

    private fun isSavedName():Boolean{
        val myName = SharedApp.prefs.name
        return myName != EMPTY_VALUE
    }
    private fun borrarJugador(){
        SharedApp.prefs.name = EMPTY_VALUE
        configView()
    }
}
